package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.GameEventConfigTypeBo;
import org.dromara.system.domain.vo.GameEventConfigTypeVo;
import org.dromara.system.domain.GameEventConfigType;
import org.dromara.system.mapper.GameEventConfigTypeMapper;
import org.dromara.system.service.IGameEventConfigTypeService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 赛事配置类型Service业务层处理
 *
 * @author zlt
 * @date 2025-07-30
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class GameEventConfigTypeServiceImpl implements IGameEventConfigTypeService {

    private final GameEventConfigTypeMapper baseMapper;

    /**
     * 查询赛事配置类型
     *
     * @param typeId 主键
     * @return 赛事配置类型
     */
    @Override
    public GameEventConfigTypeVo queryById(Long typeId){
        return baseMapper.selectVoById(typeId);
    }

    /**
     * 分页查询赛事配置类型列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 赛事配置类型分页列表
     */
    @Override
    public TableDataInfo<GameEventConfigTypeVo> queryPageList(GameEventConfigTypeBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<GameEventConfigType> lqw = buildQueryWrapper(bo);
        Page<GameEventConfigTypeVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的赛事配置类型列表
     *
     * @param bo 查询条件
     * @return 赛事配置类型列表
     */
    @Override
    public List<GameEventConfigTypeVo> queryList(GameEventConfigTypeBo bo) {
        LambdaQueryWrapper<GameEventConfigType> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<GameEventConfigType> buildQueryWrapper(GameEventConfigTypeBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<GameEventConfigType> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(GameEventConfigType::getTypeId);
        lqw.eq(StringUtils.isNotBlank(bo.getTypeCode()), GameEventConfigType::getTypeCode, bo.getTypeCode());
        lqw.like(StringUtils.isNotBlank(bo.getTypeName()), GameEventConfigType::getTypeName, bo.getTypeName());
        lqw.eq(StringUtils.isNotBlank(bo.getTypeDesc()), GameEventConfigType::getTypeDesc, bo.getTypeDesc());
        lqw.eq(StringUtils.isNotBlank(bo.getSortField()), GameEventConfigType::getSortField, bo.getSortField());
        lqw.eq(StringUtils.isNotBlank(bo.getIsEnabled()), GameEventConfigType::getIsEnabled, bo.getIsEnabled());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), GameEventConfigType::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增赛事配置类型
     *
     * @param bo 赛事配置类型
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(GameEventConfigTypeBo bo) {
        GameEventConfigType add = MapstructUtils.convert(bo, GameEventConfigType.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setTypeId(add.getTypeId());
        }
        return flag;
    }

    /**
     * 修改赛事配置类型
     *
     * @param bo 赛事配置类型
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(GameEventConfigTypeBo bo) {
        GameEventConfigType update = MapstructUtils.convert(bo, GameEventConfigType.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(GameEventConfigType entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除赛事配置类型信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
